<?php
/**
* @version      2.2.5 20.09.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

class jshopManufacturer extends JTableAvto {

    function __construct( &$_db ){
        parent::__construct( '#__jshopping_manufacturers', 'manufacturer_id', $_db );
    }

	function getAllManufacturers($publish = 0) {
		$lang = &JSFactory::getLang();
		$database =& JFactory::getDBO(); 
		$query_where = ($publish)?("WHERE manufacturer_publish = '1'"):("");
		$query = "SELECT manufacturer_id, manufacturer_url, manufacturer_logo, manufacturer_publish, `".$lang->get('name')."` as name, `".$lang->get('description')."` as description,  `".$lang->get('short_description')."` as short_description
				  FROM `#__jshopping_manufacturers` $query_where ORDER BY name";
		$database->setQuery($query);
		$list = $database->loadObjectList();
		
		foreach ($list as $key => $value){
            $list[$key]->link = SEFLink('index.php?option=com_jshopping&controller=manufacturer&task=view&manufacturer_id='.$list[$key]->manufacturer_id);
        }
		
		return $list;
	}
	
	function getName() {
        $lang = &JSFactory::getLang();
        $name = $lang->get('name');
        return $this->$name;
    }
    
    function getDescription(){
        
        if (!$this->manufacturer_id){            
            return 1; 
        }
        
        $lang = &JSFactory::getLang();
        $name = $lang->get('name');        
        $description = $lang->get('description');
        $short_description = $lang->get('short_description');
        $meta_title = $lang->get('meta_title');
        $meta_keyword = $lang->get('meta_keyword');
        $meta_description = $lang->get('meta_description');
        
        $this->name = $this->$name;
        $this->description = $this->$description;
        $this->short_description = $this->$short_description;
        $this->meta_title = $this->$meta_title;
        $this->meta_keyword = $this->$meta_keyword;
        $this->meta_description = $this->$meta_description;
    }
	
	function getProducts($order1 = null, $orderby1 = null, $order2 = null, $orderby2 = null, $limitstart = 0, $limit = 0){
        $jshopConfig = &JSFactory::getConfig();
        $lang = &JSFactory::getLang();
        $adv_query = "";
        if ($jshopConfig->hide_product_not_avaible_stock){
            $adv_query .= " AND prod.product_quantity > 0";
        }
        $order_query = "";
        if ($order1){
        	$order_query .= " ORDER BY ".$order1." ".$orderby1;
        	if ($order2){
        		$order_query .= ", ".$order2." ".$orderby2;
        	}
        }
        
        $query = "SELECT prod.*, tax.tax_value as tax, (prod.product_price*".$jshopConfig->currency_value.") AS product_price, (prod.product_price*".$jshopConfig->currency_value.")/(1+tax.tax_value/100) AS price_netto, prod.`".$lang->get('name')."` as name, prod.`".$lang->get('short_description')."` as short_description, categ.category_id
                  FROM `#__jshopping_products` AS prod
                  LEFT JOIN `#__jshopping_products_to_categories` AS categ USING (product_id)
                  INNER JOIN `#__jshopping_taxes` AS tax ON tax.tax_id = prod.product_tax_id
                  WHERE prod.product_manufacturer_id = '".$this->manufacturer_id."' AND prod.product_publish = '1' ".$adv_query."
                  GROUP BY prod.product_id ".$order_query;
        if ($limit){
            $this->_db->setQuery($query, $limitstart, $limit);
        }else{
            $this->_db->setQuery($query);
        }
        $list = $this->_db->loadObjectList();

        $userShop = &JSFactory::getUserShop();
        foreach ($list as $key => $value){
            $list[$key]->product_price = getPriceDiscount($list[$key]->product_price, $userShop->percent_discount);
        }

        return $list;
    }    
	
	function getCountProducts() {
		$jshopConfig = &JSFactory::getConfig();
        
        $adv_query = "";
        if ($jshopConfig->hide_product_not_avaible_stock){
            $adv_query .= " AND product_quantity > 0";
        }
        
		$database =& JFactory::getDBO(); 
		$query = "SELECT COUNT(*) FROM `#__jshopping_products`
                  WHERE product_manufacturer_id = '".$this->manufacturer_id."' AND product_publish = '1' ".$adv_query;
		$database->setQuery($query);
		return $database->loadResult();
	}
    
}
?>